Index: /palm/trunk/SOURCE/nesting_offl_mod.f90
===================================================================
--- /palm/trunk/SOURCE/nesting_offl_mod.f90	(revision 4833)
+++ /palm/trunk/SOURCE/nesting_offl_mod.f90	(revision 4834)
@@ -1,20 +1,19 @@
 !> @file nesting_offl_mod.f90
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 ! This file is part of the PALM model system.
 !
-! PALM is free software: you can redistribute it and/or modify it under the
-! terms of the GNU General Public License as published by the Free Software
-! Foundation, either version 3 of the License, or (at your option) any later
-! version.
-!
-! PALM is distributed in the hope that it will be useful, but WITHOUT ANY
-! WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
-! A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
-!
-! You should have received a copy of the GNU General Public License along with
-! PALM. If not, see <http://www.gnu.org/licenses/>.
+! PALM is free software: you can redistribute it and/or modify it under the terms of the GNU General
+! Public License as published by the Free Software Foundation, either version 3 of the License, or
+! (at your option) any later version.
+!
+! PALM is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
+! implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
+! Public License for more details.
+!
+! You should have received a copy of the GNU General Public License along with PALM. If not, see
+! <http://www.gnu.org/licenses/>.
 !
 ! Copyright 1997-2021 Leibniz Universitaet Hannover
-!------------------------------------------------------------------------------!
+!--------------------------------------------------------------------------------------------------!
 !
 ! Current revisions:
@@ -25,49 +24,50 @@
 ! -----------------
 ! $Id$
+! file re-formatted to follow the PALM coding standard
+!
+! 4828 2021-01-05 11:21:41Z Giersch
 ! Bugfix in obtaining the correct timestamp in case of restart runs
 !
-! 4724 2020-10-06 17:20:39Z suehring
+! 4724 2020-10-06 17:20:39Z suehring $
 ! - Enable LOD=1 input of boundary conditions
 ! - Minor bugfix - add missing initialization of the top boundary
-! 
+!
 ! 4582 2020-06-29 09:22:11Z suehring
 ! Remove unused variable
-! 
+!
 ! 4581 2020-06-29 08:49:58Z suehring
-! Omit explicit pressure forcing via geostrophic wind components in case of
-! mesoscale nesting.
-! 
+! Omit explicit pressure forcing via geostrophic wind components in case of mesoscale nesting.
+!
 ! 4561 2020-06-12 07:05:56Z suehring
 ! Adapt mass-flux correction also for the anelastic approximation
-! 
+!
 ! 4561 2020-06-12 07:05:56Z suehring
 ! use statement for exchange horiz added
-! 
+!
 ! 4360 2020-01-07 11:25:50Z suehring
-! Bugfix, time coordinate is relative to origin_time rather than to 00:00:00 
-! UTC.
-! 
+! Bugfix, time coordinate is relative to origin_time rather than to 00:00:00 UTC.
+!
 ! 4346 2019-12-18 11:55:56Z motisi
-! Introduction of wall_flags_total_0, which currently sets bits based on static
-! topography information used in wall_flags_static_0
-! 
+! Introduction of wall_flags_total_0, which currently sets bits based on static topography
+! information used in wall_flags_static_0
+!
 ! 4329 2019-12-10 15:46:36Z motisi
 ! Renamed wall_flags_0 to wall_flags_static_0
-! 
+!
 ! 4286 2019-10-30 16:01:14Z resler
 ! Fix wrong checks of time from dynamic driver in nesting_offl_mod
-! 
+!
 ! 4273 2019-10-24 13:40:54Z monakurppa
 ! Add a logical switch nesting_offline_chem
-! 
+!
 ! 4270 2019-10-23 10:46:20Z monakurppa
 ! Implement offline nesting for salsa variables.
-! 
+!
 ! 4231 2019-09-12 11:22:00Z suehring
 ! Bugfix in array deallocation
-! 
+!
 ! 4230 2019-09-11 13:58:14Z suehring
-! Update mean chemistry profiles. These are also used for rayleigh damping. 
-! 
+! Update mean chemistry profiles. These are also used for rayleigh damping.
+!
 ! 4227 2019-09-10 18:04:34Z gronemeier
 ! implement new palm_date_time_mod
@@ -77,175 +77,166 @@
 ! - time variable is now relative to time_utc_init
 ! - Define module specific data type for offline nesting in nesting_offl_mod
-! 
+!
 ! 4182 2019-08-22 15:20:23Z scharf
 ! Corrected "Former revisions" section
-! 
+!
 ! 4169 2019-08-19 13:54:35Z suehring
 ! Additional check added.
-! 
+!
 ! 4168 2019-08-16 13:50:17Z suehring
 ! Replace function get_topography_top_index by topo_top_ind
-! 
+!
 ! 4125 2019-07-29 13:31:44Z suehring
-! In order to enable netcdf parallel access, allocate dummy arrays for the 
-! lateral boundary data on cores that actually do not belong to these 
-! boundaries. 
-! 
+! In order to enable netcdf parallel access, allocate dummy arrays for the lateral boundary data on
+! cores that actually do not belong to these boundaries.
+!
 ! 4079 2019-07-09 18:04:41Z suehring
-! - Set boundary condition for w at nzt+1 at the lateral boundaries, even 
-!   though these won't enter the numerical solution. However, due to the mass
-!   conservation these values might some up to very large values which will
-!   occur in the run-control file
+! - Set boundary condition for w at nzt+1 at the lateral boundaries, even though these won't enter
+!   the numerical solution. However, due to the mass conservation these values might some up to very
+!   large values which will occur in the run-control file
 ! - Bugfix in offline nesting of chemical species
 ! - Do not set Neumann conditions for TKE and passive scalar
-! 
+!
 ! 4022 2019-06-12 11:52:39Z suehring
-! Detection of boundary-layer depth in stable boundary layer on basis of 
-! boundary data improved 
+! Detection of boundary-layer depth in stable boundary layer on basis of boundary data improved
 ! Routine for boundary-layer depth calculation renamed and made public
-! 
+!
 ! 3987 2019-05-22 09:52:13Z kanani
 ! Introduce alternative switch for debug output during timestepping
-! 
+!
 ! 3964 2019-05-09 09:48:32Z suehring
-! Ensure that veloctiy term in calculation of bulk Richardson number does not
-! become zero
-! 
+! Ensure that veloctiy term in calculation of bulk Richardson number does not become zero
+!
 ! 3937 2019-04-29 15:09:07Z suehring
-! Set boundary conditon on upper-left and upper-south grid point for the u- and
-! v-component, respectively.
-! 
+! Set boundary conditon on upper-left and upper-south grid point for the u- and v-component,
+! respectively.
+!
 ! 3891 2019-04-12 17:52:01Z suehring
-! Bugfix, do not overwrite lateral and top boundary data in case of restart 
-! runs. 
-! 
+! Bugfix, do not overwrite lateral and top boundary data in case of restart runs.
+!
 ! 3885 2019-04-11 11:29:34Z kanani
-! Changes related to global restructuring of location messages and introduction 
-! of additional debug messages
-! 
-! 
-! Do local data exchange for chemistry variables only when boundary data is  
-! coming from dynamic file
-! 
+! Changes related to global restructuring of location messages and introduction of additional debug
+! messages
+!
+!
+! Do local data exchange for chemistry variables only when boundary data is coming from dynamic file
+!
 ! 3737 2019-02-12 16:57:06Z suehring
 ! Introduce mesoscale nesting for chemical species
-! 
+!
 ! 3705 2019-01-29 19:56:39Z suehring
 ! Formatting adjustments
-! 
+!
 ! 3704 2019-01-29 19:51:41Z suehring
-! Check implemented for offline nesting in child domain 
-! 
-! Initial Revision: 
+! Check implemented for offline nesting in child domain
+!
+! Initial Revision:
 ! - separate offline nesting from large_scale_nudging_mod
 ! - revise offline nesting, adjust for usage of synthetic turbulence generator
-! - adjust Rayleigh damping depending on the time-depending atmospheric
-!   conditions
-! 
-! 
+! - adjust Rayleigh damping depending on the time-depending atmospheric conditions
+!
+!
 ! Description:
 ! ------------
-!> Offline nesting in larger-scale models. Boundary conditions for the simulation
-!> are read from NetCDF file and are prescribed onto the respective arrays.
-!> Further, a mass-flux correction is performed to maintain the mass balance. 
-!--------------------------------------------------------------------------------!
+!> Offline nesting in larger-scale models. Boundary conditions for the simulation are read from
+!> NetCDF file and are prescribed onto the respective arrays.
+!> Further, a mass-flux correction is performed to maintain the mass balance.
+!--------------------------------------------------------------------------------------------------!
  MODULE nesting_offl_mod
 
-    USE arrays_3d,                                                             &
-        ONLY:  dzw,                                                            &
-               e,                                                              &
-               drho_air_zw,                                                    &
-               diss,                                                           &
-               pt,                                                             &
-               pt_init,                                                        &
-               q,                                                              &
-               q_init,                                                         &
-               rdf,                                                            &
-               rdf_sc,                                                         &
-               rho_air,                                                        &
-               rho_air_zw,                                                     &
-               s,                                                              &
-               u,                                                              &
-               u_init,                                                         &
-               ug,                                                             &
-               v,                                                              &
-               v_init,                                                         &
-               vg,                                                             &
-               w,                                                              &
-               zu,                                                             &
+    USE arrays_3d,                                                                                 &
+        ONLY:  diss,                                                                               &
+               drho_air_zw,                                                                        &
+               dzw,                                                                                &
+               e,                                                                                  &
+               pt,                                                                                 &
+               pt_init,                                                                            &
+               q,                                                                                  &
+               q_init,                                                                             &
+               rdf,                                                                                &
+               rdf_sc,                                                                             &
+               rho_air,                                                                            &
+               rho_air_zw,                                                                         &
+               s,                                                                                  &
+               u,                                                                                  &
+               u_init,                                                                             &
+               ug,                                                                                 &
+               v,                                                                                  &
+               v_init,                                                                             &
+               vg,                                                                                 &
+               w,                                                                                  &
+               zu,                                                                                 &
                zw
 
-    USE basic_constants_and_equations_mod,                                     &
-           ONLY:  g,                                                           &
-                  pi
-
-    USE chem_modules,                                                          &
+    USE basic_constants_and_equations_mod,                                                         &
+        ONLY:  g,                                                                                  &
+               pi
+
+    USE chem_modules,                                                                              &
         ONLY:  chem_species, nesting_offline_chem
 
-    USE control_parameters,                                                    &
-        ONLY:  air_chemistry,                                                  & 
-               bc_dirichlet_l,                                                 & 
-               bc_dirichlet_n,                                                 &
-               bc_dirichlet_r,                                                 &
-               bc_dirichlet_s,                                                 &
-               coupling_char,                                                  &
-               dt_3d,                                                          &
-               dz,                                                             &
-               constant_diffusion,                                             &
-               child_domain,                                                   &
-               debug_output_timestep,                                          &
-               end_time,                                                       &
-               humidity,                                                       &
-               initializing_actions,                                           &
-               message_string,                                                 &
-               nesting_offline,                                                &
-               neutral,                                                        &
-               passive_scalar,                                                 &
-               rans_mode,                                                      &
-               rans_tke_e,                                                     &
-               rayleigh_damping_factor,                                        & 
-               rayleigh_damping_height,                                        &
-               salsa,                                                          &
-               spinup_time,                                                    &
-               time_since_reference_point,                                     &
+    USE control_parameters,                                                                        &
+        ONLY:  air_chemistry,                                                                      &
+               bc_dirichlet_l,                                                                     &
+               bc_dirichlet_n,                                                                     &
+               bc_dirichlet_r,                                                                     &
+               bc_dirichlet_s,                                                                     &
+               coupling_char,                                                                      &
+               constant_diffusion,                                                                 &
+               child_domain,                                                                       &
+               debug_output_timestep,                                                              &
+               dt_3d,                                                                              &
+               dz,                                                                                 &
+               end_time,                                                                           &
+               humidity,                                                                           &
+               initializing_actions,                                                               &
+               message_string,                                                                     &
+               nesting_offline,                                                                    &
+               neutral,                                                                            &
+               passive_scalar,                                                                     &
+               rans_mode,                                                                          &
+               rans_tke_e,                                                                         &
+               rayleigh_damping_factor,                                                            &
+               rayleigh_damping_height,                                                            &
+               salsa,                                                                              &
+               spinup_time,                                                                        &
+               time_since_reference_point,                                                         &
                volume_flow
 
-    USE cpulog,                                                                &
-        ONLY:  cpu_log,                                                        &
-               log_point,                                                      &
+    USE cpulog,                                                                                    &
+        ONLY:  cpu_log,                                                                            &
+               log_point,                                                                          &
                log_point_s
 
     USE grid_variables
 
-    USE indices,                                                               &
-        ONLY:  nbgp, nx, nxl, nxlg, nxlu, nxr, nxrg, ny, nys,                  &
-               nysv, nysg, nyn, nyng, nzb, nz, nzt,                            &
-               topo_top_ind,                                                   &
-               wall_flags_total_0
+    USE indices,                                                                                   &
+        ONLY:  nbgp, nx, nxl, nxlg, nxlu, nxr, nxrg, ny, nys, nysv, nysg, nyn, nyng, nzb, nz, nzt, &
+               topo_top_ind, wall_flags_total_0
 
     USE kinds
 
-    USE netcdf_data_input_mod,                                                 &
-        ONLY:  char_fill,                                                      &
-               char_lod,                                                       &
-               check_existence,                                                &
-               close_input_file,                                               &
-               get_attribute,                                                  &
-               get_dimension_length,                                           &
-               get_variable,                                                   &
-               get_variable_pr,                                                &
-               input_pids_dynamic,                                             &
-               inquire_num_variables,                                          &
-               inquire_variable_names,                                         &
-               input_file_dynamic,                                             &
-               num_var_pids,                                                   &
-               open_read_file,                                                 &
+    USE netcdf_data_input_mod,                                                                     &
+        ONLY:  char_fill,                                                                          &
+               char_lod,                                                                           &
+               check_existence,                                                                    &
+               close_input_file,                                                                   &
+               get_attribute,                                                                      &
+               get_dimension_length,                                                               &
+               get_variable,                                                                       &
+               get_variable_pr,                                                                    &
+               input_pids_dynamic,                                                                 &
+               inquire_num_variables,                                                              &
+               inquire_variable_names,                                                             &
+               input_file_dynamic,                                                                 &
+               num_var_pids,                                                                       &
+               open_read_file,                                                                     &
                pids_id
 
     USE pegrid
 
-    USE salsa_mod,                                                             &
-        ONLY:  salsa_nesting_offl_bc,                                          &
-               salsa_nesting_offl_init,                                        &
+    USE salsa_mod,                                                                                 &
+        ONLY:  salsa_nesting_offl_bc,                                                              &
+               salsa_nesting_offl_init,                                                            &
                salsa_nesting_offl_input
 
@@ -257,16 +248,21 @@
     TYPE nest_offl_type
 
-       CHARACTER(LEN=16) ::  char_l = 'ls_forcing_left_'  !< leading substring for variables at left boundary 
-       CHARACTER(LEN=17) ::  char_n = 'ls_forcing_north_' !< leading substring for variables at north boundary  
-       CHARACTER(LEN=17) ::  char_r = 'ls_forcing_right_' !< leading substring for variables at right boundary  
-       CHARACTER(LEN=17) ::  char_s = 'ls_forcing_south_' !< leading substring for variables at south boundary 
-       CHARACTER(LEN=15) ::  char_t = 'ls_forcing_top_'   !< leading substring for variables at top boundary 
+       CHARACTER(LEN=16) ::  char_l = 'ls_forcing_left_'   !< leading substring for variables at left boundary
+       CHARACTER(LEN=17) ::  char_n = 'ls_forcing_north_'  !< leading substring for variables at north boundary
+       CHARACTER(LEN=17) ::  char_r = 'ls_forcing_right_'  !< leading substring for variables at right boundary
+       CHARACTER(LEN=17) ::  char_s = 'ls_forcing_south_'  !< leading substring for variables at south boundary
+       CHARACTER(LEN=15) ::  char_t = 'ls_forcing_top_'    !< leading substring for variables at top boundary
 
        CHARACTER(LEN=100), DIMENSION(:), ALLOCATABLE ::  var_names         !< list of variable in dynamic input file
-       CHARACTER(LEN=100), DIMENSION(:), ALLOCATABLE ::  var_names_chem_l  !< names of mesoscale nested chemistry variables at left boundary
-       CHARACTER(LEN=100), DIMENSION(:), ALLOCATABLE ::  var_names_chem_n  !< names of mesoscale nested chemistry variables at north boundary
-       CHARACTER(LEN=100), DIMENSION(:), ALLOCATABLE ::  var_names_chem_r  !< names of mesoscale nested chemistry variables at right boundary
-       CHARACTER(LEN=100), DIMENSION(:), ALLOCATABLE ::  var_names_chem_s  !< names of mesoscale nested chemistry variables at south boundary
-       CHARACTER(LEN=100), DIMENSION(:), ALLOCATABLE ::  var_names_chem_t  !< names of mesoscale nested chemistry variables at top boundary
+       CHARACTER(LEN=100), DIMENSION(:), ALLOCATABLE ::  var_names_chem_l  !< names of mesoscale nested chemistry variables at left
+                                                                           !< boundary
+       CHARACTER(LEN=100), DIMENSION(:), ALLOCATABLE ::  var_names_chem_n  !< names of mesoscale nested chemistry variables at north
+                                                                           !< boundary
+       CHARACTER(LEN=100), DIMENSION(:), ALLOCATABLE ::  var_names_chem_r  !< names of mesoscale nested chemistry variables at right
+                                                                           !< boundary
+       CHARACTER(LEN=100), DIMENSION(:), ALLOCATABLE ::  var_names_chem_s  !< names of mesoscale nested chemistry variables at south
+                                                                           !< boundary
+       CHARACTER(LEN=100), DIMENSION(:), ALLOCATABLE ::  var_names_chem_t  !< names of mesoscale nested chemistry variables at top
+                                                                           !< boundary
 
        INTEGER(iwp) ::  lod_east_pt  = 2  !< level-of-detail of input data of potential temperature at the eastern boundary
@@ -308,18 +304,28 @@
        LOGICAL      ::  init = .FALSE.    !< flag indicating that offline nesting is already initialized
 
-       LOGICAL, DIMENSION(:), ALLOCATABLE ::  chem_from_file_l !< flags inidicating whether left boundary data for chemistry is in dynamic input file  
-       LOGICAL, DIMENSION(:), ALLOCATABLE ::  chem_from_file_n !< flags inidicating whether north boundary data for chemistry is in dynamic input file 
-       LOGICAL, DIMENSION(:), ALLOCATABLE ::  chem_from_file_r !< flags inidicating whether right boundary data for chemistry is in dynamic input file 
-       LOGICAL, DIMENSION(:), ALLOCATABLE ::  chem_from_file_s !< flags inidicating whether south boundary data for chemistry is in dynamic input file 
-       LOGICAL, DIMENSION(:), ALLOCATABLE ::  chem_from_file_t !< flags inidicating whether top boundary data for chemistry is in dynamic input file 
-
-       REAL(wp), DIMENSION(:), ALLOCATABLE ::  surface_pressure !< time dependent surface pressure
-       REAL(wp), DIMENSION(:), ALLOCATABLE ::  time             !< time levels in dynamic input file
-       REAL(wp), DIMENSION(:), ALLOCATABLE ::  zu_atmos         !< vertical levels at scalar grid in dynamic input file
-       REAL(wp), DIMENSION(:), ALLOCATABLE ::  zw_atmos         !< vertical levels at w grid in dynamic input file
+       LOGICAL, DIMENSION(:), ALLOCATABLE ::  chem_from_file_l  !< flags inidicating whether left boundary data for chemistry is in
+                                                                !< dynamic input file
+       LOGICAL, DIMENSION(:), ALLOCATABLE ::  chem_from_file_n  !< flags inidicating whether north boundary data for chemistry is in
+                                                                !< dynamic input file
+       LOGICAL, DIMENSION(:), ALLOCATABLE ::  chem_from_file_r  !< flags inidicating whether right boundary data for chemistry is in
+                                                                !< dynamic input file
+       LOGICAL, DIMENSION(:), ALLOCATABLE ::  chem_from_file_s  !< flags inidicating whether south boundary data for chemistry is in
+                                                                !< dynamic input file
+       LOGICAL, DIMENSION(:), ALLOCATABLE ::  chem_from_file_t  !< flags inidicating whether top boundary data for chemistry is in
+                                                                !< dynamic input file
+
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  surface_pressure  !< time dependent surface pressure
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  time              !< time levels in dynamic input file
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  zu_atmos          !< vertical levels at scalar grid in dynamic input file
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  zw_atmos          !< vertical levels at w grid in dynamic input file
 
        REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  ug         !< domain-averaged geostrophic component
        REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  vg         !< domain-averaged geostrophic component
 
+       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  pt_l     !< potentital temperautre at left boundary
+       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  pt_n     !< potentital temperautre at north boundary
+       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  pt_r     !< potentital temperautre at right boundary
+       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  pt_s     !< potentital temperautre at south boundary
+       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  pt_top   !< potentital temperautre at top boundary
        REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  q_l      !< mixing ratio at left boundary
        REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  q_n      !< mixing ratio at north boundary
@@ -327,9 +333,4 @@
        REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  q_s      !< mixing ratio at south boundary
        REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  q_top    !< mixing ratio at top boundary
-       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  pt_l     !< potentital temperautre at left boundary
-       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  pt_n     !< potentital temperautre at north boundary
-       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  pt_r     !< potentital temperautre at right boundary
-       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  pt_s     !< potentital temperautre at south boundary
-       REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  pt_top   !< potentital temperautre at top boundary
        REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  u_l      !< u-component at left boundary
        REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  u_n      !< u-component at north boundary
